import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Table from './table';

class DataGridSection extends Component {
  constructor(props) {
    super(props);
    this.onPagination = this.onPagination.bind(this);
    this.onSort = this.onSort.bind(this);
    this.onSearch = this.onSearch.bind(this);
  }

  onSort(colId) {
    this.props.onSort(colId);
  }

  onSearch(searchInput) {
    this.props.onSearch(searchInput);
  }

  onPagination(event) {
    this.props.onPagination(event);
  }

  render() {
    const style = this.props.styleData ? this.props.styleData.gridWrapper : null;
    return (
      <div className="data-grid" style={style}>
        <div className="content" style={style}>
          <Table
            data={this.props.data}
            metaData={this.props.metaData}
            styleData={this.props.styleData}
            onSort={this.onSort}
            onSearch={this.onSearch}
            onPagination={this.onPagination}
            gridState={this.props.gridState}
          />
        </div>
      </div>
    );
  }
}

DataGridSection.propTypes = {
  data: PropTypes.array,
  metaData: PropTypes.object,
  styleData: PropTypes.object,
};

DataGridSection.defaultProps = {
  data: [],
  metaData: {},
  styleData: {},
};

export default DataGridSection;
