export const addUniqueKey = (data) => {
  let id = 0;
  data.forEach((obj) => {
    obj.id = id.toString();
    id += 1;
  });
  return data;
};

export const isEmpty = (data) => {
  for (const key in data) {
    if (Object.hasOwnProperty.call(data, key)) return false;
  }
  return true;
};

export const getNoOfPages = (data, recordsPerPage) => {
  const pageCount = [];
  if (data) {
    for (let i = 1; i <= Math.ceil(data.length / recordsPerPage); i += 1) {
      pageCount.push(i);
    }
    return pageCount.length;
  } else {
    return 0;
  }

};

export const getFilterData = (filterConfig, data) => {
  const { searchEntity, selectedColumn } = filterConfig;
  const searchedData = [];
  if (searchEntity === '') {
    return null;
  } else if (selectedColumn !== 'all') {
    return data.filter(
      x => x[selectedColumn].toLowerCase().includes(searchEntity.toLowerCase()),
    );
  }

  data.forEach((object) => {
    for (const key in object) {
      if (object[key].toLowerCase().indexOf(searchEntity.toLowerCase()) !== -1) {
        searchedData.push(object);
      }
    }
  });

  return _.uniq(searchedData, results => results.id);
};

export const getData = (state) => {
  if (state.data != null) {
    if (state.recordsPerPage) {
      const indexOfLastRecord = state.currentPage * state.recordsPerPage;
      const indexOfFirstRecord = indexOfLastRecord - state.recordsPerPage;
      return state.data.slice(indexOfFirstRecord, indexOfLastRecord);
    }
    return state.data;
  }

};
